; INPUT.ASM
; part of Ben's Command Extender
; input procs
; 14 Dec 97
; blm
;


; input
; input a string from user
; returns length of string 
input:
	push	bx
	push	cx
	push	dx
	
	call	flush
	mov		ax, string
	mov		cx, 255
	call	gets
	sub		ax, 2
	and		ax, ax
	jz		.error
	mov		cx, ax
	mov		dx, string
	mov		ax, string
	call	strncpy
	mov		ax, string
	call	puts
	mov		ax, cx
	jmp		.done

.error:
	xor		ax, ax
	
.done:
	pop		dx
	pop		cx
	pop		bx
	ret	
	
	
	
; gets
; read a string from standard input
; ax points to string and cx is max string length
; returns number of characters read
gets:
	push	bx
	push	dx
	push	ds
	
	mov		dx, ax
	mov		ax, cs
	mov		ds, ax
	xor		bx, bx
	mov		ah, 3Fh
	int		21h
	jnc		.done
	xor		ax, ax
	
.done
	pop		ds
	pop		dx
	pop		bx
	ret
	
	
	




; flush
; flush standard input
flush:
	push	ax
	mov		ax, 0C00h
	int		21h
	pop		ax
	ret
	
	
	
; input data

